
import
  preserves, std/tables

type
  WebsocketArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `url`*: string

  WebsocketArguments* {.preservesRecord: "websocket".} = object
    `field0`*: WebsocketArgumentsField0

  JsonTranslatorArgumentsField0* {.preservesDictionary.} = object
    `argv`*: seq[string]
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  JsonTranslatorArguments* {.preservesRecord: "json-stdio-translator".} = object
    `field0`*: JsonTranslatorArgumentsField0

  JsonTranslatorConnected* {.preservesRecord: "connected".} = object
    `path`*: string

  JsonSocketTranslatorArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `socket`*: string

  JsonSocketTranslatorArguments* {.preservesRecord: "json-socket-translator".} = object
    `field0`*: JsonSocketTranslatorArgumentsField0

  RrdArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  RrdArguments* {.preservesRecord: "rrd".} = object
    `field0`*: RrdArgumentsField0

  WebhooksArgumentsField0* {.preservesDictionary.} = object
    `endpoints`*: Table[seq[string], EmbeddedRef]
    `listen`*: Tcp

  WebhooksArguments* {.preservesRecord: "webhooks".} = object
    `field0`*: WebhooksArgumentsField0

  FileSystemUsageArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  FileSystemUsageArguments* {.preservesRecord: "file-system-usage".} = object
    `field0`*: FileSystemUsageArgumentsField0

  SqliteArgumentsField0* {.preservesDictionary.} = object
    `database`*: string
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  SqliteArguments* {.preservesRecord: "sqlite".} = object
    `field0`*: SqliteArgumentsField0

  CacheArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `lifetime`*: float32

  CacheArguments* {.preservesRecord: "cache".} = object
    `field0`*: CacheArgumentsField0

  Tcp* {.preservesRecord: "tcp".} = object
    `host`*: string
    `port`*: BiggestInt

proc `$`*(x: WebsocketArguments | JsonTranslatorArguments |
    JsonTranslatorConnected |
    JsonSocketTranslatorArguments |
    RrdArguments |
    WebhooksArguments |
    FileSystemUsageArguments |
    SqliteArguments |
    CacheArguments |
    Tcp): string =
  `$`(toPreserves(x))

proc encode*(x: WebsocketArguments | JsonTranslatorArguments |
    JsonTranslatorConnected |
    JsonSocketTranslatorArguments |
    RrdArguments |
    WebhooksArguments |
    FileSystemUsageArguments |
    SqliteArguments |
    CacheArguments |
    Tcp): seq[byte] =
  encode(toPreserves(x))
